#include "started_pch.h"
// For standard C++ printing (std::cout)
#include <iostream>
// For Naming Service capabilities
#include "orbsvcs/CosNamingC.h"
// The Servant

#include "SimpleInterface_i.h"

int main (int argc, char *argv[])
{
// Use ACE-specific TRY/CATCH mechanism
ACE_TRY_NEW_ENV
{
// Initialize and error check ORB
CORBA::ORB_var orb = CORBA::ORB_init (argc, argv);
if (CORBA::is_nil(orb.in()))
{
std::cout << "Could not initialize ORB" << std::endl;
exit(1);
}
// Initialize and error check POA objects (Root POA, POA Manager)
CORBA::Object_var poa_object = orb->resolve_initial_references("RootPOA");
if (CORBA::is_nil(poa_object.in()))
{
std::cout << "Could not initialize POA Object" << std::endl;
exit(1);
}
PortableServer::POA_var root_poa = PortableServer::POA::_narrow
(poa_object.in ());
if (CORBA::is_nil(root_poa.in()))
{
std::cout << "Could not initialize Root POA" << std::endl;
}
PortableServer::POAManager_var poa_manager = root_poa->the_POAManager ();
if (CORBA::is_nil(poa_manager.in()))
{
std::cout << "Could not initialize POA Manager" << std::endl;
exit(1);
}
// Initialize and error check Naming Service objects
CORBA::Object_var NameServiceObjectVar = orb->resolve_initial_references("NameService");
if (CORBA::is_nil(NameServiceObjectVar.in()))
{
std::cout << "Could not initialize Naming Service" << std::endl;
exit(1);
}
CosNaming::NamingContext_var NamingContextVar =
CosNaming::NamingContext::_narrow(NameServiceObjectVar.in());
if (CORBA::is_nil(NamingContextVar.in()))
{
std::cout << "Could not initialize Naming Context" << std::endl;
exit(1);
}
// Initialize and activate Servant object
SimpleInterface_i Ucast_servant (orb.in ());
root_poa->activate_object(&Ucast_servant);
// Place Servants name in the Naming Service
CosNaming::Name UCastName(1);
UCastName.length(1);
UCastName[0].id = CORBA::string_dup("Serv1");
SimpleInterface_var UcastTemp = Ucast_servant._this();
NamingContextVar->rebind(UCastName, UcastTemp.in());
// Activate POA, run ORB (Servant now listening for incoming requests)
poa_manager->activate ();
orb->run();
// POA and ORB cleanup
root_poa->destroy(1, 1);
orb->destroy();
}
ACE_CATCHANY
{
ACE_PRINT_EXCEPTION (ACE_ANY_EXCEPTION,
"Exception caught:");
return 1;
}
ACE_ENDTRY;
return 0;
}
